import { test, describe } from "vitest";

import { expectSolution } from "../01/main.js";
import { solutionPart1, puzzleInput, sample } from "./part1.js";
import { solutionPart2 } from "./part2.js";

describe("part 1", () => {
  test("sample", () => {
    expectSolution(solutionPart1(sample)).toEqual(2);
  });
  test("solution", () => {
    expectSolution(solutionPart1(puzzleInput)).toEqual(605);
  });
});

describe("part 2", () => {
  test("sample", () => {
    expectSolution(solutionPart2(sample)).toEqual(4);
  });
  test("solution", () => {
    expectSolution(solutionPart2(puzzleInput)).toEqual(914);
  });
});
